<template>
	<div style="text-align: center;">
		<div style="width:800px;float: left; margin-left: 10px;margin-bottom: 10px;">
			<el-input v-model="query.material" size="small" placeholder="名称或编码" style="width :300px;float: left;"></el-input>
			<el-input v-model="query.standard" size="small" placeholder="钢种" style="width :300px;float: left;"></el-input>
			<el-button type="info" size="small" @click="search">查询</el-button>
			<el-button type="primary" size="small" @click="handleAdd">新增</el-button>
		</div>

		<div style="padding-right: 30px;">
			<el-table v-loading="loading" :data="tableData" border>
				<el-table-column prop="id" label="编号" width="60"  v-if="isShow">
				</el-table-column>
				<el-table-column prop="name" label="物料名称" width="120">
				</el-table-column>
				<el-table-column prop="code" label="物料编码" width="120">
				</el-table-column>
				<el-table-column prop="standard" label="种类" width="120">
				</el-table-column>
				<el-table-column prop="model" label="尺寸" width="120">
				</el-table-column>
				<el-table-column label="操作">
					<template slot-scope="scope">
						<el-button size="mini" @click="handleEdit(scope.row)">编辑</el-button>
						<el-button size="mini" type="danger" @click="handleDelete(scope.row.id)">删除</el-button>
					</template>
				</el-table-column>
			</el-table>
		</div>
		<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage"
		 :page-sizes="pageSizes" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="totalRows">
		</el-pagination>



		<el-dialog title="物料明细" :visible.sync="dialogVisible" width="500px">
			<el-form :model="material" label-width="100px">
				<el-form-item label="id" v-if="isShow">
					<el-input v-model="material.id"></el-input>
				</el-form-item>
				<el-form-item label="物料名称">
					<el-input v-model="material.name"></el-input>
				</el-form-item>
				<el-form-item label="物料编码">
					<el-input v-model="material.code"></el-input>
				</el-form-item>
				<el-form-item label="种类">
					<el-input v-model="material.standard"></el-input>
				</el-form-item>
				 		<el-form-item label="尺寸">
				 	<el-input v-model="material.model"></el-input>
				 </el-form-item>
				<el-form-item>
					<el-button type="success" @click="handleSave">保存</el-button>
					<el-button @click="handleCancelSave">取消</el-button>
				</el-form-item>
			</el-form>

		</el-dialog>


	</div>
</template>

<script>
	import axios from '@/axios'
	export default {
		components: {

		},
		data() {
			return {
				//表格初始化参数
				tableData: [],
				currentPage: 1,
				totalRows: 0,
				pageSizes: [50, 100, 200,500],
				pageSize: 50,
				//查询条件
			query: {
				material: '',
				standard: '',
			},
				//录入框
				dialogVisible: false,
				material: {
					id: '',
					name: '',
					code: '',
					standard: '',
					model: '',
				},
				isShow: false,
				loading: true,

			}
		},
		//界面渲染完毕调用   初始化表格参数
		mounted() {
			this.getTableData()
		},
		methods: {
			// 获取table数据
			getTableData() {
				this.loading = true
				var url = 'MaintMaterial/query.do'
				var param = {
					page: this.currentPage,
					rows: this.pageSize,
					material: this.query.material,
					standard: this.query.standard,
				}
				axios.get(url, param).then(response => {
					if (response.data.code == 0) {
						this.tableData = response.data.data.list
						this.totalRows = response.data.data.total
					} else {
						this.$message({
							type: 'error',
							message: '失败！' + response.data.msg,
						});
					}
					this.loading = false
				});
			},
			// 修改每页条数事件
			handleSizeChange(val) {
				console.log(`每页 ${val} 条`);
				this.pageSize = val
				this.getTableData()
			},
			// 修改当前页事件
			handleCurrentChange(val) {
				console.log(`当前页: ${val}`);
				this.currentPage = val
				this.getTableData()
			},
 
			//保存按钮事件
			handleSave(row) {
				var json = JSON.stringify(this.material)
				var url = 'MaintMaterial/save.do'
				var param = {
					json: json
				}
				axios.post(url, param).then(response => {
					if (response.data.code == 0) {
						this.$message({
							type: 'success',
							message: '保存成功!',
						});
						this.getTableData()
						this.dialogVisible = false
					} else {
						this.$message({
							type: 'error',
							message: '保存失败' + response.data.msg,
						});
					}
					// loading.close();
				});



			},
			//保存取消按钮事件   关闭编辑对话框
			handleCancelSave(row) {
				this.dialogVisible = false
			},
			// 新增按钮事件
			handleAdd() {
				this.dialogVisible = true
				this.material= {
					id: '',
					name: '',
					code: '',
					standard: '',
					model: '',
				} 
			 
			},
			// 编辑按钮事件
			handleEdit(row) {
				this.dialogVisible = true
				this.material = row
			},

			// 删除按钮事件
			handleDelete(id) {
				this.$confirm('此操作将删除该数据, 是否继续?', '提示', {
					confirmButtonText: '确定',
					cancelButtonText: '取消',
					type: 'warning'
				}).then(() => {

					var url = 'MaintMaterial/remove.do'
					var param = {
						id: id
					}
					axios.post(url, param).then(response => {
						if (response.data.code == 0) {
							this.$message({
								type: 'success',
								message: '删除成功!',
							});
							this.getTableData()
						} else {
							this.$message({
								type: 'error',
								message: '删除失败;' + response.data.msg
							});
						}
					});
				}).catch(() => {
					this.$message({
						type: 'info',
						message: '已取消删除'
					});
				});
			},
			// 查询按钮事件
			search() {
				this.currentPage = 1
				this.getTableData()
			}
		}
	}
</script>
